module adder_test;
reg [3:0] A,B;
reg Cin;
wire [3:0] Sum;
wire Cout;
reg [3:0] S_compare; 
reg C_compare;
adder dev(A,B,Cin,Sum,Cout);
integer n, m;
integer start;
initial
begin
	Cin = 0;
	 A[3:0] = 4'b0000;
	 B[3:0] = 4'b0000;
for (n=0; n<16; n=n+1)
	begin
		A = n;
		for (m=0; m<16; m=m+1)
		begin
			B = m;
			{C_compare, S_compare} = A + B;
			start = $time;
			#10;
		end
	end
end
initial
	begin
	$monitor("time %0d %d A = %4b B = %4b out = %4b Cout = %b %s",
		$time,$time-start,A,B,Sum,Cout,
		(Sum==S_compare)&&(Cout==C_compare)? "okay": "fail");
	end
endmodule
		